import json
import time
import os
import threading
import subprocess
import pipes

from SanPySchedule.SanSchedulerCore import SchedulerCore

class SanPySchedule:
    def __init__(self, schedFile):
        self._schedFile = schedFile
        self._pyJobDetails = None
        self._schedule = SchedulerCore()
        self._readSchedulerJson()
    
    def _readSchedulerJson(self):
        with open(self._schedFile, "r") as fd:
            try:
                self._pyJobDetails = json.load(fd)
                fd.close()
            except:
                print("Error in Reading schedular configuration.")
    
    def _printSchedulerJson(self):
        for jobDetail in self._pyJobDetails['pyJobDetails']:
            print('Job Name:' + jobDetail.get('pyJobName'))
            print('Job Schedule:' + jobDetail.get('pyJobSchedule'))

    def _runInThread(self, jobFunction, cmdName):
        threadJob = threading.Thread(target=jobFunction(cmdName))
        threadJob.start()

    def _externalJob(self, cmdName):
        #print("Running The Scheduled Job: [" + cmdName + "]")
        
        os.system(cmdName);
        #python didn't run unix standard re-direction operators
        #hence used os.system to execute
        #I will debug later
        #cmdArgs = str(cmdName).split()
        #subprocess.run(cmdArgs, stdout=True)
        
        
        # proc = subprocess.Popen(cmdArgs, stdout=subprocess.PIPE)
        # stdout = proc.communicate()
        # print( 'STDOUT:{}'.format(stdout))

    def _internalJob(self):
        pass

    def scheduleAllJobs(self):
        for jobDetail in self._pyJobDetails['pyJobDetails']:
            fldJobName = str(jobDetail.get('pyJobName'))
            fldSchedule = str(jobDetail.get('pyJobSchedule'))
            fldInterval = fldSchedule.split('-')

            if fldInterval[1] == 'day':
                self._schedule.every().day.at(fldInterval[2]).do(
                    self._runInThread, self._externalJob, fldJobName)
            elif fldInterval[1] == 'minute':
                self._schedule.every(int(fldInterval[2])).minutes.do(
                    self._runInThread, self._externalJob, fldJobName)
            elif fldInterval[1] == 'seconds':
                self._schedule.every(int(fldInterval[2])).seconds.do(
                    self._runInThread , self._externalJob, fldJobName)
            elif fldInterval[1] == 'week':
                eval("self._schedule.every().week." + fldInterval[2] + \
                    ".at('" + fldInterval[3] + "').do( \
                    self._runInThread, self._externalJob, fldJobName)")
            else:
                print("Invalid Key Value in JSON")
        
        while True:
            self._schedule.run_pending()
            time.sleep(1)


# def main():
#     pjs = SanPySchedule('SanJobTab.json')
#     #pjs.printSchedularJson()
#     pjs.scheduleAllJobs()


if __name__ == "__main__":
    pass
